#!/usr/bin/python

import os
import glob

CMakeLists_TXT = 'CMakeLists.txt'
SEPREATOR = '\n    '
SOURCE_NAME = 'xx_SRC'
HEADER_NAME = 'xx_HEADER'


sources = []
headers = []
ignoreDirs = []

_root = os.getcwd()
for root, dirs, files in os.walk(os.getcwd()):
    parent = os.path.dirname(root)
    ignore = False
    for dir in ignoreDirs:
        if dir in parent:
            ignore = True
            break
    if ignore:
        continue

    path = os.path.join(root, CMakeLists_TXT)
    CMakeLists = glob.glob(path)
    if len(CMakeLists) > 0:
        ignoreDirs.append(root)
        continue

    for filename in files:
        if filename.startswith('.'):
            continue
        f = os.path.join(root, filename).replace(_root, '${CMAKE_CURRENT_LIST_DIR}')
        fname, ext = os.path.splitext(filename)
        ext = ext.lower()
        if ext == '.cpp' or ext == '.c':
            sources.append(f)
        elif ext == '.hpp' or ext == '.h':
            headers.append(f)
        else:
            print(ext + " skip: " + filename)



sources = sorted(sources)
headers = sorted(headers)

text_src = 'set(' + SOURCE_NAME + SEPREATOR +  SEPREATOR.join(sources) + SEPREATOR + ")"
text_header = 'set(' + HEADER_NAME + SEPREATOR +  SEPREATOR.join(headers) + SEPREATOR + ")"
text = text_src + '\n\n' + text_header + "\n"

with open(CMakeLists_TXT, 'w') as f:
    f.write(text)